#include <stdio.h>
#include <string.h>
#include <sys/mount.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>

int worker(char *fsts){

  char *p, *specialfile, *dir, *filesystemtype, *rest;
  unsigned long rwflag;
  FILE *f;
  int i, found;
  char buf[1024];

  p = strstr(fsts,"your fstab entries are");
  if ( p == (char *) 0 ) {
    printf("\nnothing mountable found - please try again\n");
    return(-1);
  }
  p += 23;
  while( (*p != '\n') && (*p != '\0') ){
    specialfile = p;
    while ( (*p != '\0' ) && (*p != ' ') ) p++;
    if ( *p != ' ') {
      printf("\nnothing mountable found - please try again\n");
      return(-1);
    }
    *p++ = '\0';
    dir = p;
    while ( (*p != '\0' ) && (*p != ' ') ) p++;
    if ( *p != ' ') {
      printf("\nnothing mountable found - please try again\n");
      return(-1);
    }
    *p++ = '\0';
    filesystemtype = p;
    while ( (*p != '\0' ) && (*p != ' ') ) p++;
    if ( *p != ' ') {
      printf("\nnothing mountable found - please try again\n");
      return(-1);
    }
    *p++ = '\0';
    rest = p;
    while ( (*p != '\0' ) && (*p != '\n') ) p++;
    if ( *p != '\n') {
      printf("\nnothing mountable found - please try again\n");
      return(-1);
    }
    *p++ = '\0';
/*
    rwflag = MS_MGC_VAL;
    if ( strstr(rest,"ro"    ) )  rwflag &= MS_RDONLY;
    if ( strstr(rest,"nosuid") )  rwflag &= MS_NOSUID;
    if ( strstr(rest,"nodev" ) )  rwflag &= MS_NODEV;
    if ( strstr(rest,"noexec") )  rwflag &= MS_NOEXEC;
    if ( strstr(rest,"sync"  ) )  rwflag &= MS_SYNCHRONOUS;
 */
    printf("creating %s\n", dir);
    p = dir;
    p++;
    while ( *p != '\0' ) {
      while ( (*p != '\0' ) && (*p != '/') ) p++;
      if ( *p == '/' ) {
        *p = '\0';
        if ( mkdir( dir, 0755 ) && ( errno != EEXIST) ) {
	  perror("Home Dir Creation failed");
	  return(-1);
	}
	*p = '/';
	p++;
      }
    }
    if ( mkdir( dir, 0755 ) && ( errno != EEXIST) ) {
      perror("Home Dir Creation failed");
      return(-1);
    }

/*  havn't got this to work yet.  data seems to want to be a **char
    if (  mount( specialfile, dir, filesystemtype, rwflag, 0 ) ) {
      perror("Home Dir Mount failed");
      return(-1);
    }
 */

    printf("mounting %s\n", dir);
    /* just throw it at fstab and call /bin/mount */
    f = fopen("/etc/fstab","r+");
    if ( f == (FILE *) NULL ) {
	perror("error opening fstab");
	return(-1);
    }
    found = 0;
    while ( ( ! feof(f) ) && (fgets( buf, 1024, f) ) ) {
      if ( strstr(buf,dir) ) {found = 1; break;}
    }
    if ( ! found ) {
      sprintf(buf,"%s %s %s %s\n", specialfile, dir, filesystemtype, rest);

      if ( fputs(buf,f) < 0 ){
	fclose(f);
	perror("error writing fstab");
	return(-1);
      }
    }
    fclose(f);

    f = fopen("/etc/mtab","r");
    if ( f == (FILE *) NULL ) {
	perror("error opening mtab");
	return(-1);
    }
    found = 0;
    while ( ( ! feof(f) ) && (fgets( buf, 1024, f) ) ) {
      if ( strstr(buf,dir) ) {found = 1; break;}
    }
    if ( ! found ) {
	sleep(2);
      sprintf(buf,"mount %s",dir);
      i = system(buf);
      if ( i ) {
	printf("mount failed");
        fclose(f);
        return(-1);
      }
    }
    fclose(f);
  }
  return(0);
}
